=== debian/changelog ===
chibi-scheme (0.9.1-3ubuntu0.22.04.1) jammy; urgency=medium

  * d/control: Add runtime dependency to fix install failure. (LP: #2009694)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 15 Apr 2024 19:05:14 +0100

chibi-scheme (0.9.1-3) unstable; urgency=medium

  * Adjust debian/rules to upstream Makefile API change

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 25 Nov 2020 20:10:04 +0000

chibi-scheme (0.9.1-2) unstable; urgency=medium

  * Update renamed lintian tag names in lintian overrides.
  * Bump policy
  * Track upstream changes including bug fix for library symbols missing
    on 32-bit architectures (closes: #972956)
  * Forward port patches (one spelling correct merged upstream)

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 25 Nov 2020 16:33:43 +0000

chibi-scheme (0.9.1-1) unstable; urgency=medium

  * Initial Debian release. (Closes: #928753)
    - Thanks to Alexei Lozovsky <me@ilammy.net> who did all the hard lifting.

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 06 Sep 2020 14:22:27 +0100
