=== debian/control ===
Source: chibi-scheme
Section: lisp
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper-compat (= 13)
Rules-Requires-Root: no
Standards-Version: 4.5.1
Homepage: https://github.com/ashinn/chibi-scheme
Vcs-Browser: https://salsa.debian.org/scheme-team/chibi-scheme
Vcs-Git: https://salsa.debian.org/scheme-team/chibi-scheme.git

Package: chibi-scheme
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: chibi-scheme-common
Suggests: chibi-scheme-doc
Description: embeddable Scheme interpreter
 Chibi-Scheme is a really small embeddable interpreter of R7RS Scheme,
 intended for use as an extension and scripting language in C programs.
 .
 This package provides REPL and interpreter "chibi-scheme"
 as well as tools for documenting Scheme code ("chibi-doc"),
 generating FFI bindings ("chibi-ffi"),
 and managing Scheme packages ("snow-chibi").

Package: chibi-scheme-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: chibi-scheme
Description: embeddable Scheme interpreter (documentation)
 Chibi-Scheme is a really small embeddable interpreter of R7RS Scheme,
 intended for use as an extension and scripting language in C programs.
 .
 This package provides documentation on the interpreter library,
 FFI interfaces, and built-in extension modules.

Package: chibi-scheme-common
Architecture: all
Depends: libchibi-scheme-ffi (>= 0.9.1), ${misc:Depends}
Description: embeddable Scheme interpreter (standard libraries)
 Chibi-Scheme is a really small embeddable interpreter of R7RS Scheme,
 intended for use as an extension and scripting language in C programs.
 .
 This package provides the standard library for R7RS Scheme, as well as
 some additional extension libraries.

Package: chibi-scheme-images
Architecture: all
Depends: chibi-scheme-common (= ${binary:Version}), ${misc:Depends}, chibi-scheme (>= ${source:Version})
Description: embeddable Scheme interpreter (standard library images)
 Chibi-Scheme is a really small embeddable interpreter of R7RS Scheme,
 intended for use as an extension and scripting language in C programs.
 .
 A dummy package providing preloaded images for use with "chibi-scheme -i".
 They allow faster startup times when using common library sets.

Package: libchibi-scheme0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: embeddable Scheme interpreter (shared library)
 Chibi-Scheme is a really small embeddable interpreter of R7RS Scheme,
 intended for use as an extension and scripting language in C programs.
 .
 This package provides the core shared library for applications that
 are using Chibi.

Package: libchibi-scheme-dev
Section: libdevel
Architecture: any
Depends: libchibi-scheme0 (= ${binary:Version}), ${misc:Depends}
Suggests: chibi-scheme-doc
Description: embeddable Scheme interpreter (development files)
 Chibi-Scheme is a really small embeddable interpreter of R7RS Scheme,
 intended for use as an extension and scripting language in C programs.
 .
 This package provides the header files, libraries, and symbolic links
 necessary to build applications that use Chibi-Scheme and extension
 modules for Chibi-Scheme.

Package: libchibi-scheme-ffi
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: chibi-scheme-common
Description: embeddable Scheme interpreter (native modules)
 Chibi-Scheme is a really small embeddable interpreter of R7RS Scheme,
 intended for use as an extension and scripting language in C programs.
 .
 This package provides native binary modules required by some of the
 libraries in Chibi's standard package.
