=== debian/watch ===
version=4
https://github.com/ashinn/@PACKAGE@/releases \
 .*/v?@ANY_VERSION@@ARCHIVE_EXT@
